unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient,  ExtCtrls, OleCtrls, Ofis_TLB, DB, ADODB, Buttons;

type

  TfrmMain = class(TForm)
    mmText: TMemo;
    edtName: TEdit;
    Label4: TLabel;
    BitBtn1: TButton;
    btnVerify: TButton;
    btnSetLang: TButton;
    btnOK: TButton;
    qryInsert: TADOQuery;
    ADOConnection1: TADOConnection;
    lblCount: TLabel;
    btnSaveAsJpg: TButton;
    btnSaveAsBmp: TButton;
    btnRegTemplateFromFile: TButton;
    Label1: TLabel;
    lblFgrIndex: TLabel;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    btnInitSensor: TButton;
    cboLanguage: TComboBox;
    edtKey: TEdit;
    Label2: TLabel;
    edtText1: TEdit;
    Label3: TLabel;
    Label5: TLabel;
    edtText2: TEdit;
    btnEncrypt: TBitBtn;
    btnDecrypt: TBitBtn;
    btnGetThreshold: TButton;
    btnSetThreshold: TButton;
    Label6: TLabel;
    edt1To1: TEdit;
    btnVerTemplateFromFile: TButton;
    Label7: TLabel;
    edtRegDpi: TEdit;
    edtVerDPI: TEdit;
    Label8: TLabel;
    GroupBox1: TGroupBox;
    btnAddTpl: TButton;
    OfisMain1: TOfisMain;
    btnIdentify: TButton;
    btnRegBuffer: TButton;
    Label9: TLabel;
    edtUserName: TEdit;
    Label10: TLabel;
    GroupBox2: TGroupBox;
    edtID: TEdit;
    btnRemove: TButton;
    rbtn10: TRadioButton;
    rbtn9: TRadioButton;
    Label11: TLabel;
    procedure FormShow(Sender: TObject);
    procedure btnVerifyClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnSetLangClick(Sender: TObject);
    function RegisterUser(sUser:String;sFinger:widestring):boolean;
    function Verify(sFinger:widestring):String;
    procedure btnSaveAsJpgClick(Sender: TObject);
    procedure btnSaveAsBmpClick(Sender: TObject);
    procedure btnInitSensorClick(Sender: TObject);
    procedure btnRegTemplateFromFileClick(Sender: TObject);
    procedure btnEncryptClick(Sender: TObject);
    procedure btnDecryptClick(Sender: TObject);
    procedure btnGetThresholdClick(Sender: TObject);
    procedure btnSetThresholdClick(Sender: TObject);
    procedure btnVerTemplateFromFileClick(Sender: TObject);
    procedure btnAddTplClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnIdentifyClick(Sender: TObject);
    procedure btnRegBufferClick(Sender: TObject);
    procedure btnRemoveClick(Sender: TObject);
    procedure rbtn9Click(Sender: TObject);
    procedure rbtn10Click(Sender: TObject);
  private
    { Private declarations }
    g_sRegTpl, g_sTpl2, g_sFPVer:widestring;
  public
    { Public declarations }
    FpHandle:THandle;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.FormShow(Sender: TObject);
begin
  mmText.Lines.Clear;
  OfisMain1.Visible:=False;
  cboLanguage.ItemIndex:=0;
   mmText.Lines.Add('CheckFinger: '+OfisMain1.CheckFinger);
  FpHandle := 0;
  g_sFPVer:='9';
end;

procedure TfrmMain.btnVerifyClick(Sender: TObject);
var
sVryFgr, sMsg:String;
begin
         OfisMain1.SetFPEngineVersion(strtoint(g_sFPVer));
        if OfisMain1.GetVerTemplate then
        begin
            sVryFgr:=OfisMain1.VerifyTemplate;
            g_sTpl2 := sVryFgr;
            sMsg:=Verify(sVryFgr);
            mmText.Lines.Append('Verified : '+sMsg);
            //mmText.Lines.Append(sVryFgr);
            ShowMessage('Verified : '+sMsg);
        end;
end;

procedure TfrmMain.BitBtn1Click(Sender: TObject);
begin
  OfisMain1.SetFPEngineVersion(strtoint(g_sFPVer));
  OfisMain1.IsAutoRegister := True;
  OfisMain1.CheckFinger:='1000000000';  // left thumb index =1 , right thumb index = 6; set 1=check, 0=uncheck  ; example check left thumb = 1000000000, check right thumb = 0000010000
  if OfisMain1.Register = true then
  begin

       lblFgrIndex.Caption := inttostr(OfisMain1.FingerIndex);   //register finger index
       showMessage('Please enter your user name.');

       edtName.Enabled:=True;
       edtName.SetFocus;
       btnOK.Enabled:=True;
       mmText.Lines.Add('CheckFinger: '+OfisMain1.CheckFinger);
  end;
end;

procedure TfrmMain.btnOKClick(Sender: TObject);
var
sRegFgr, sUserName:String;
iCount, iFgr:Integer;
begin
      sRegFgr:=OfisMain1.RegisterTemplate;
      sUserName := edtName.Text;
      iCount := 1;
      iFgr := 0;
            
      while (iCount <= 10) do
      begin
           if Length(OfisMain1.GetRegFingerTemplate(iCount))> 0 then
           begin
              RegisterUser(sUserName,OfisMain1.GetRegFingerTemplate(iCount));
              Inc(iFgr);
           end;
           Inc(iCount);
      end;
      mmText.Lines.Append('Registered User : '+sUserName+' No of fingerprint:'+inttostr(iFgr));

end;

procedure TfrmMain.btnSetLangClick(Sender: TObject);
var
sLang:String;
begin

    case cbolanguage.ItemIndex of
    0: begin
          sLang:='Ofis.en';
       end;
    1: begin
          sLang:='Ofis.chs';
       end;
    2: begin
         sLang:='Ofis.cht';
       end;
    3: begin
         sLang:='Ofis.my';
       end;
    4: begin
         sLang:='Ofis.spa';
       end;
    5: begin
         sLang:='Ofis.arb';
       end;
     end;


  if OfisMain1.SetLanguageFile(sLang) then
    Showmessage('OK')
  else
    showmessage('Failed');
end;

function TfrmMain.RegisterUser(sUser:String;sFinger:widestring):boolean;
begin
        Result:=False;
        with qryInsert do
        begin
               Insert;
               fieldByName('fingertemplate').AsString := sFinger;
               fieldByName('username').AsString :=sUser ;
               fieldByName('policy').AsString :=g_sFPVer ;
               try
               Connection.BeginTrans;
               Post;
               Connection.CommitTrans;
               except  on E:Exception do Connection.RollbackTrans;end;
        end;
        Result:=True;

end;

function TfrmMain.Verify(sFinger:widestring):String;
var
bVerify:boolean;
sTFinger:widestring;
iCount:Integer;
sUser:String;
begin
  qryInsert.Close;
  qryInsert.SQL.Clear;
  qryInsert.SQL.Add('SELECT * FROM USERS WHERE POLICY = '''+g_sFPVer+'''');
  qryInsert.Open;
  qryInsert.First;

  bVerify:=False;
  iCount:=1;


    mmText.Lines.Append('Matching Start :'+FormatDateTime('hh:mm:ss.zzz', now));
    Result:='false';
    while (not qryInsert.Eof) and (bVerify=False)do
    begin

        sTFinger:=qryInsert.fieldByName('fingertemplate').AsString;
        sUser:=qryInsert.fieldByName('username').AsString;
              
        if OfisMain1.MatchFinger(sTFinger, sFinger) then
        begin

            Result:=sUser;
            bVerify:=True;

            mmText.Lines.Append('Matching End :'+FormatDateTime('hh:mm:ss.zzz', now));
            Exit;
        end
        else
        begin

            qryInsert.Next;
        end;       
        iCount:=iCount+1;
        lblCount.Caption:=inttostr(iCount);
        lblCount.Update;

    end;
    mmText.Lines.Append('Matching End :'+FormatDateTime('hh:mm:ss.zzz', now));
end;

procedure TfrmMain.btnSaveAsJpgClick(Sender: TObject);
begin
   SaveDialog1.FilterIndex:=1;
   SaveDialog1.DefaultExt:='.jpg';
   if SaveDialog1.Execute then
   begin
       	// save the last captured finger template into jpg format	(use register or verify to capture finger first)
       OfisMain1.SaveFingerTemplateAsJPG(SaveDialog1.FileName);
   end;
end;

procedure TfrmMain.btnSaveAsBmpClick(Sender: TObject);
begin
 SaveDialog1.FilterIndex:=2;
 SaveDialog1.DefaultExt:='.bmp';
   if SaveDialog1.Execute then
   begin
       	// save the last captured finger template into bmp format	(use register or verify to capture finger first)
       OfisMain1.SaveFingerTemplateAsBMP(SaveDialog1.FileName);
   end;
end;

procedure TfrmMain.btnInitSensorClick(Sender: TObject);
begin
    //result =0 success, 1 = Not install driver, 2 = Not connect sensor
    OfisMain1.SetFPEngineVersion(strtoint(g_sFPVer));
    showMessage('Init result : '+inttostr(OfisMain1.InitSensor));

end;


procedure TfrmMain.btnEncryptClick(Sender: TObject);
begin
      edtText2.Text := OfisMain1.Encrypt(edtText1.Text,edtKey.Text);
end;

procedure TfrmMain.btnDecryptClick(Sender: TObject);
begin
     edtText1.Text := OfisMain1.Decrypt(edtText2.Text,edtKey.Text);
end;

procedure TfrmMain.btnGetThresholdClick(Sender: TObject);
begin
      edt1To1.Text := inttostr(OfisMain1.OneToOneThreshold);
      mmText.Lines.Add('OneToOneThreshold: '+edt1To1.Text);


end;

procedure TfrmMain.btnSetThresholdClick(Sender: TObject);
var
i:Integer;
begin
       i := strtoint(edt1To1.Text);
       OfisMain1.OneToOneThreshold := i;
       mmText.Lines.Add('Set OneToOneThreshold OK');
end;

procedure TfrmMain.btnRegTemplateFromFileClick(Sender: TObject);
var
sFileName:String;
sFgr:widestring;
begin

    if Length(edtName.text)= 0 then
    begin
        MessageDlg('Please enter UserName before load image!',mtWarning,[mbok],0);
        edtName.SetFocus;
        Exit;
    end;


    if OpenDialog1.Execute then
    begin
       //load finger image file, convert into string format
        sFgr := OfisMain1.GetRegTemplateFromFile(OpenDialog1.FileName,strtoint(edtRegDpi.Text))  ;
        g_sRegTpl := sFgr;
       // mmText.Lines.Add('OK');
        If RegisterUser(edtName.text,sFgr) then
           mmText.Lines.Append('Registered User :'+edtName.text);
    end;

end;



procedure TfrmMain.btnVerTemplateFromFileClick(Sender: TObject);
var
sFileName:String;
sFgr:widestring;
bChanged : wordbool;
begin
    if OpenDialog1.Execute then
   begin
       //load finger image file, convert into string format
       sFgr := OfisMain1.GetVerTemplateFromFile(OpenDialog1.FileName,strtoint(edtVerDpi.Text));
                           
       mmText.Lines.Add('Verified : '+Verify(sFgr));  	//matching finger
      {
      if OfisMain1.MatchFinger(g_sRegTpl,sFgr) = true then
         mmText.Lines.Add('True')
      else
         mmText.Lines.Add('False');
      }
    end;

end;

procedure TfrmMain.btnAddTplClick(Sender: TObject);
var
iUserID, iRet, iCount:Integer;
sTpl:Widestring;

begin
      if OfisMain1.InitSensor = 0 then
      begin
        FpHandle := OfisMain1.CreateBuffer;
        qryInsert.Close;
        qryInsert.SQL.Clear;
        qryInsert.SQL.Add('SELECT * FROM USERS WHERE POLICY = '''+g_sFPVer+'''');
        qryInsert.Open;
        qryInsert.First;
        iCount:=0;
        while not qryInsert.eof do
        begin
            iUserID := qryInsert.fieldbyName('id').AsInteger;
            sTpl := qryInsert.fieldbyName('fingertemplate').AsString;
            iRet := OfisMain1.AddRegTemplateToBuffer(FpHandle,iUserID,sTpl);
            if iRet = 0 then
              mmText.Lines.Add('Add User '+inttostr(iUserID)+' failed')
            else
              Inc(iCount);

            qryInsert.Next;
        end;
         mmText.Lines.Add('Added '+inttostr(iCount)+' templates into buffer');
      end
      else
      begin
         ShowMessage('Init OFIS sensor failed!');
      end;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
        if FpHandle <> 0 then
           OfisMain1.FreeBuffer(FpHandle);
end;

procedure TfrmMain.btnIdentifyClick(Sender: TObject);
var
sVryFgr:widestring;
iUserID:Integer;
begin
        if OfisMain1.GetVerTemplate then
        begin
            sVryFgr:=OfisMain1.VerifyTemplate;
            iUserID := OfisMain1.IdentificationTemplateFromBuffer(FpHandle,sVryFgr);
            if iUserID <> -1 then
            begin
              qryInsert.Locate('id',iUserID,[]);
              mmText.Lines.Append('Verified - ID:'+inttostr(iUserID)+' Name:'+qryInsert.FieldByName('username').AsString);
            end
            else
             mmText.Lines.Append('Verified failed!');
            //mmText.Lines.Append(sVryFgr);
         end;
end;

procedure TfrmMain.btnRegBufferClick(Sender: TObject);
var
sRegFgr:widestring;
begin
        If edtUserName.Text='' then
        begin
            showMessage('Please enter your user name.');
            edtUserName.SetFocus;
            Exit;

        end;
        OfisMain1.IsAutoRegister := True;
        OfisMain1.CheckFinger:='1000000000';  // left thumb index =1 , right thumb index = 6; set 1=check, 0=uncheck  ; example check left thumb = 1000000000, check right thumb = 0000010000
        if OfisMain1.Register = true then
        begin
          lblFgrIndex.Caption := inttostr(OfisMain1.FingerIndex);   //register finger index
          sRegFgr:=OfisMain1.RegisterTemplate;
          RegisterUser(edtUserName.Text,sRegFgr);
          qryInsert.Close;
          qryInsert.Open;
          qryInsert.Locate('username',edtUserName.Text,[]);
          
          if OfisMain1.AddRegTemplateToBuffer(FpHandle,qryInsert.FieldByName('id').AsInteger,sRegFgr) = 0 then
        //  if OfisMain1.AddRegTemplateToBuffer(FpHandle,999999999,sRegFgr) = 0 then
             mmText.Lines.Append('Register template into buffer failed!')
          else
             mmText.Lines.Append('Register template into buffer succesful!');
        end;
end;

procedure TfrmMain.btnRemoveClick(Sender: TObject);
var
iUserID:Integer;
begin
          iUserID:=strtoint(edtID.Text);
          if OfisMain1.RemoveRegTemplateFromBuffer(FpHandle,iUserID) = 0 then
             mmText.Lines.Append('Remove ID from buffer failed!')
          else
             mmText.Lines.Append('Remove ID from buffer succesful!');

end;

procedure TfrmMain.rbtn9Click(Sender: TObject);
begin
          OfisMain1.SetFPEngineVersion(9);
          g_sFPVer:='9';
end;

procedure TfrmMain.rbtn10Click(Sender: TObject);
begin
         OfisMain1.SetFPEngineVersion(10);
          g_sFPVer:='10';
end;

end.
