﻿Imports System.Data.OleDb
Imports System.Data.Common
Imports System.Data
Imports Ofis

Public Class Form1
    Inherits System.Windows.Forms.Form

    Dim axOfisMain1 As New OfisMain
    Dim g_sFgr1, g_sFgr2, g_sFPVer As String
    Dim FHandle As Integer

    Public Sub New()
        MyBase.New()

        ' This call is required by the designer.
        InitializeComponent()
        Me.Icon = New System.Drawing.Icon(Application.StartupPath + "\ofis.ico")
        Me.cboSetLanguage.Items.AddRange(New Object() {"ENGLISH", "CHINESE SIMPLIFIED", "CHINESE TRADITIONAL", "MALAY", "SPANISH", "ARABIC"})
        g_sFPVer = "9"
        axOfisMain1.SetFPEngineVersion(9)
        ' Add any initialization after the InitializeComponent() call.

    End Sub

    Private Sub btnSetLanguage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetLanguage.Click
        Select Case cboSetLanguage.Text
            Case "ENGLISH"
                If (axOfisMain1.SetLanguageFile("Ofis.en")) Then
                    MessageBox.Show("OK")
                Else
                    MessageBox.Show("Failed")
                End If
            Case "CHINESE SIMPLIFIED"
                If (axOfisMain1.SetLanguageFile("Ofis.chs")) Then
                    MessageBox.Show("OK")
                Else
                    MessageBox.Show("Failed")
                End If
            Case "CHINESE TRADITIONAL"
                If (axOfisMain1.SetLanguageFile("Ofis.cht")) Then
                    MessageBox.Show("OK")
                Else
                    MessageBox.Show("Failed")
                End If
            Case "MALAY"
                If (axOfisMain1.SetLanguageFile("Ofis.my")) Then
                    MessageBox.Show("OK")
                Else
                    MessageBox.Show("Failed")
                End If
            Case "SPANISH"
                If (axOfisMain1.SetLanguageFile("Ofis.sp")) Then
                    MessageBox.Show("OK")
                Else
                    MessageBox.Show("Failed")
                End If
            Case "ARABIC"
                If (axOfisMain1.SetLanguageFile("Ofis.ar")) Then
                    MessageBox.Show("OK")
                Else
                    MessageBox.Show("Failed")
                End If
        End Select
    End Sub

    Private Sub btnPlayBeep_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPlayBeep.Click
        axOfisMain1.InitSensor()
        axOfisMain1.PlayBeep(True)
        axOfisMain1.PlayBeep(False)
    End Sub

    Private Sub btnPlayGreen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPlayGreen.Click
        axOfisMain1.InitSensor()
        axOfisMain1.PlayGreenLight(True)
        axOfisMain1.PlayGreenLight(False)
    End Sub

    Private Sub btnPlayRed_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPlayRed.Click
        axOfisMain1.InitSensor()
        axOfisMain1.PlayRedLight(True)
        axOfisMain1.PlayRedLight(False)
    End Sub

    
    Private Sub btnSaveJPG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveJPG.Click
        SaveFileDialog1.DefaultExt = "jpg"
        SaveFileDialog1.Filter = "Jpeg files (*.jpg)|*.jpg|All files (*.*)|*.*"
        SaveFileDialog1.ShowDialog()
        axOfisMain1.SaveFingerTemplateAsJPG(SaveFileDialog1.FileName)
    End Sub

    Private Sub btnSaveBMP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveBMP.Click
        SaveFileDialog1.DefaultExt = "bmp"
        SaveFileDialog1.Filter = "BMP  files (*.bmp)|*.bmp|All files (*.*)|*.*"
        SaveFileDialog1.ShowDialog()
        axOfisMain1.SaveFingerTemplateAsJPG(SaveFileDialog1.FileName)
    End Sub

    Private Sub btnEncrypt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEncrypt.Click
        txtStrDec.Text = axOfisMain1.Encrypt(txtStrEnc.Text, txtKey.Text)
    End Sub

    Private Sub btnDecrypt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDecrypt.Click
        txtStrEnc.Text = axOfisMain1.Decrypt(txtStrDec.Text, txtKey.Text)
    End Sub

    Private Sub btnGet1to1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGet1to1.Click
        txt1to1Threshold.Text = axOfisMain1.OneToOneThreshold.ToString()
        listBox1.Items.Add("Get One To One Threshold: " + txt1to1Threshold.Text)
    End Sub

    Private Sub btnSet1to1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSet1to1.Click
        axOfisMain1.OneToOneThreshold = Convert.ToInt32(txt1to1Threshold.Text)
        listBox1.Items.Add("Set One To One Threshold: " + txt1to1Threshold.Text + " OK")
    End Sub

    Private Sub rdbnine_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdbnine.CheckedChanged
        If (rdbnine.Checked) Then
            g_sFPVer = "9"
            axOfisMain1.SetFPEngineVersion(9)
        End If
    End Sub

    Private Sub rdbten_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdbten.CheckedChanged
        If (rdbten.Checked) Then
            g_sFPVer = "10"
            axOfisMain1.SetFPEngineVersion(10)
        End If
    End Sub

    Private Sub btnInit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInit.Click
        If (rdbnine.Checked) Then
            axOfisMain1.SetFPEngineVersion(9)
        Else
            axOfisMain1.SetFPEngineVersion(10)
        End If

        Select Case axOfisMain1.InitSensor().ToString()
            Case "0"
                MessageBox.Show("Success", "OFIS 3.0", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Case "1"
                MessageBox.Show("Not install driver", "OFIS 3.0", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Case "2"
                MessageBox.Show("Not connect sensor", "OFIS 3.0", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Select
    End Sub

    Private Sub btnVerify_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnVerify.Click
        Dim sFgr As String

        If (rdbnine.Checked) Then
            axOfisMain1.SetFPEngineVersion(9)
        Else
            axOfisMain1.SetFPEngineVersion(10)
        End If

        If (axOfisMain1.GetVerTemplate()) Then
            sFgr = axOfisMain1.VerifyTemplate
            g_sFgr2 = sFgr
            Verify(sFgr)
        End If
    End Sub

    Private Sub btnRegister_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRegister.Click
        If (rdbnine.Checked) Then
            axOfisMain1.SetFPEngineVersion(9)
        Else
            axOfisMain1.SetFPEngineVersion(10)
        End If

        axOfisMain1.IsAutoRegister = True
        axOfisMain1.CheckFinger = "0000000000" 'left thumb index =1 , right thumb index = 6; set 1=check, 0=uncheck  ; example check left thumb = 1000000000, check right thumb = 0000010000

        If (axOfisMain1.Register()) Then
            Dim i As Integer
            i = axOfisMain1.FingerIndex
            lblFingerIndexResult.Text = i.ToString()

            MessageBox.Show("Please enter your username")
            txtUsername.Focus()
            btnOK.Enabled = True

            listBox1.Items.Add("CheckFinger: " + axOfisMain1.CheckFinger)
        End If
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Dim sRegTpl As String
        Dim i As Integer
        i = 1

        While (i <= 10)
            sRegTpl = axOfisMain1.GetRegFingerTemplate(i)
            If (String.IsNullOrEmpty(sRegTpl) = False) Then
                Register(sRegTpl)
            End If
            i = i + 1
        End While
    End Sub

    Private Sub Verify(ByVal sFgr As String)
        Dim sTplFgr, sUser, sResult As String
        Dim bMatched As Boolean
        Dim cn As OleDbConnection
        Dim cmd As OleDbCommand
        Dim dr As OleDbDataReader
        sResult = ""
        bMatched = False

        listBox1.Items.Add("Matching Start  " + DateTime.Now.ToString("f"))

        cn = New OleDbConnection("Jet OLEDB:Global Partial Bulk Ops=2;" +
            "Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;" +
            "Data Source='OfisDemo.mdb';Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;" +
            "Provider='Microsoft.Jet.OLEDB.4.0';Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;" +
            "Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;" +
            "Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False")
        cn.Open()
        cmd = New OleDbCommand("select * from users where policy = '" + g_sFPVer + "' order by id", cn)
        dr = cmd.ExecuteReader()
        While (dr.Read() And bMatched = False)
            sUser = dr(1)
            sTplFgr = dr(4)

            If axOfisMain1.MatchFinger(sTplFgr, sFgr) = True Then ' matching finger template
                bMatched = True
                sResult = sUser
            End If
        End While
        dr.Close()
        cn.Close()

        If sResult = "" Then
            sResult = "False"
        End If

        listBox1.Items.Add("Verified :" + sResult)
        listBox1.Items.Add("Matching End  " + FormatDateTime(DateTime.Now, 0))
        listBox1.Items.Add("--------------------------------------------------------------------------------")
    End Sub

    Private Sub Register(ByVal sFgr As String)
        Dim cn As OleDbConnection
        Dim cmd As OleDbCommand
        Dim iCount As Integer
        Dim str As String

        cn = New OleDbConnection("Jet OLEDB:Global Partial Bulk Ops=2;" +
            "Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;" +
            "Data Source='OfisDemo.mdb';Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;" +
            "Provider='Microsoft.Jet.OLEDB.4.0';Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;" +
            "Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;" +
            "Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False")
        cn.Open()
        str = "insert into Users (username, fingertemplate, policy) values (@edtUserName, @RegisterTemplate, @policy)"
        cmd = New OleDbCommand(str, cn)
        cmd.Parameters.Add("@edtUserName", OleDbType.Char).Value = txtUsername.Text
        cmd.Parameters.Add("@RegisterTemplate", OleDbType.Char).Value = sFgr
        cmd.Parameters.Add("@Policy", OleDbType.Char).Value = g_sFPVer

        iCount = cmd.ExecuteNonQuery()
        cn.Close()

        MessageBox.Show("Inserted  record")
        listBox1.Items.Add("Registered User : " + txtUsername.Text)
    End Sub

    Private Sub btnVerTplFromFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnVerTplFromFile.Click
        If (rdbnine.Checked) Then
            axOfisMain1.SetFPEngineVersion(9)
        Else
            axOfisMain1.SetFPEngineVersion(10)
        End If

        OpenFileDialog1.ShowDialog()
        Dim sFgr As String

        sFgr = axOfisMain1.GetVerTemplateFromFile(OpenFileDialog1.FileName, Convert.ToInt32(txtDPI1.Text))
        If (String.IsNullOrEmpty(sFgr) = False) Then
            Verify(sFgr)
        End If
    End Sub

    Private Sub btnRegTplFromFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRegTplFromFile.Click
        If (rdbnine.Checked) Then
            axOfisMain1.SetFPEngineVersion(9)
        Else
            axOfisMain1.SetFPEngineVersion(10)
        End If

        Dim sFgr As String
        If (String.IsNullOrEmpty(txtUsername.Text) = True) Then
            MessageBox.Show("Please enter your username")
        Else
            OpenFileDialog1.ShowDialog()
            sFgr = axOfisMain1.GetRegTemplateFromFile(OpenFileDialog1.FileName, Convert.ToInt32(txtDPI.Text))
            If (String.IsNullOrEmpty(sFgr) = False) Then
                Register(sFgr)
            End If
        End If
    End Sub

    Private Sub btnAddTempBuffer_Click(sender As System.Object, e As System.EventArgs) Handles btnAddTempBuffer.Click
        Dim sTplFgr As String
        Dim sUser, counter, result As Integer
        Dim cn As OleDbConnection
        Dim cmd As OleDbCommand
        Dim dr As OleDbDataReader
        axOfisMain1.InitSensor()

        FHandle = axOfisMain1.CreateBuffer()

        counter = 0

        Try ' connect to OfisDemo.mdb
            cn = New OleDbConnection("Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;Data Source='OfisDemo.mdb';Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;Provider='Microsoft.Jet.OLEDB.4.0';Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False")
            cn.Open()
            cmd = New OleDbCommand("SELECT * FROM USERS WHERE POLICY = '" + g_sFPVer + "'", cn) ' query all users
            dr = cmd.ExecuteReader

            While (dr.Read())
                sUser = dr.Item("id")
                sTplFgr = dr.Item("fingertemplate")

                result = axOfisMain1.AddRegTemplateToBuffer(FHandle, sUser, sTplFgr)
                If result = 0 Then
                    listBox1.Items.Add("Add User " + Convert.ToString(sUser) + " failed")
                Else
                    counter = counter + 1
                End If
            End While
            dr.Close()
            cn.Close()
        Catch
        End Try
        listBox1.Items.Clear()
        listBox1.Items.Add("Added Fingerprint to Buffer: " + counter.ToString())

    End Sub

    Private Sub btnIdentificationBuffer_Click(sender As System.Object, e As System.EventArgs) Handles btnIdentificationBuffer.Click
        Dim userid As Integer
        Dim sTplFgr As String

        axOfisMain1.GetVerTemplate()
        sTplFgr = axOfisMain1.VerifyTemplate
        
        userid = axOfisMain1.IdentificationTemplateFromBuffer(FHandle, sTplFgr)

        listBox1.Items.Add("--------------------------------------------------------------------------------")
        listBox1.Items.Add("Matching Start  " + FormatDateTime(DateTime.Now, 0))
        If (userid <> -1) Then
            listBox1.Items.Add("Verified Fingerprint: " + userid.ToString())
        Else
            listBox1.Items.Add("Verified failed!")
        End If
        listBox1.Items.Add("Matching End  " + FormatDateTime(DateTime.Now, 0))
        listBox1.Items.Add("--------------------------------------------------------------------------------")
        txtUsernameBuffer.Text = ""
        txtUserIDBuffer.Text = ""
    End Sub

    Private Sub btnRegisterTempBuffer_Click(sender As System.Object, e As System.EventArgs) Handles btnRegisterTempBuffer.Click
        Dim sRegFgr As String
        Dim cn As OleDbConnection
        Dim cmd As OleDbCommand
        Dim dr As OleDbDataReader
        Dim userid As Integer
        Dim result As String
        result = ""

        If (txtUsernameBuffer.Text = "") Then
            MessageBox.Show("Please enter your user name.")
            txtUsernameBuffer.Focus()
        Else
                Try ' connect to OfisDemo.mdb
                    cn = New OleDbConnection("Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;Data Source='OfisDemo.mdb';Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;Provider='Microsoft.Jet.OLEDB.4.0';Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False")
                    cn.Open()
                    cmd = New OleDbCommand("select id from users", cn) ' query all users
                    dr = cmd.ExecuteReader

                While (dr.Read())
                    userid = dr.Item("id")
                    If (userid = txtUsernameBuffer.Text) Then
                        result = "duplicate"
                    End If
                End While

                    If Not String.IsNullOrEmpty(result) Then
                        MessageBox.Show("Duplicate User ID. Please insert others ID.")
                    Else
                    axOfisMain1.IsAutoRegister = True
                    axOfisMain1.CheckFinger = "1000000000"  '// left thumb index =1 , right thumb index = 6; set 1=check, 0=uncheck  ; example check left thumb = 1000000000, check right thumb = 0000010000"
                    If (axOfisMain1.Register = True) Then
                        lblFingerIndexResult.Text = Convert.ToString(axOfisMain1.FingerIndex)   '//register finger index
                        sRegFgr = axOfisMain1.RegisterTemplate
                        If axOfisMain1.AddRegTemplateToBuffer(FHandle, userid, sRegFgr) = 0 Then
                            listBox1.Items.Add("Register template into buffer failed!")
                        Else
                            listBox1.Items.Add("Register template into buffer succesful!")
                        End If
                        cn.Close()
                    End If
                End If
                Catch
                End Try

            End If
    End Sub

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        axOfisMain1.FreeBuffer(FHandle)
    End Sub

    Private Sub btnRemoveIDBuffer_Click(sender As System.Object, e As System.EventArgs) Handles btnRemoveIDBuffer.Click
        Dim iUserID As Integer

        If (txtUserIDBuffer.Text = "") Then
            MessageBox.Show("Please enter your user ID.")
            txtUserIDBuffer.Focus()
        Else
            iUserID = Convert.ToInt32(txtUserIDBuffer.Text)
            If (axOfisMain1.RemoveRegTemplateFromBuffer(FHandle, iUserID) = 0) Then
                listBox1.Items.Add("Remove ID from buffer failed!")
            Else
                listBox1.Items.Add("Remove ID from buffer succesful!")
            End If
        End If
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

    End Sub

End Class


